/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mnenhy.
 *
 * The Initial Developer of the Original Code is Karsten Düsterloh <mnenhy@tprac.de>.
 *
 * Portions created by the Initial Developer are Copyright (C) 2002-2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Karsten Düsterloh <mnenhy@tprac.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// +-
// |  These Mozilla MailNews functions are overloaded here:
// |    initializeHeaderViewTables()
// |    UpdateMessageHeaders()
// |    messageHeaderSink.onStartHeaders()
// |    messageHeaderSink.processHeaders(headerNames, headerValues, numHeaders, dontCollectAddress)
// |  Last checked for changes: 2004-12-15
// +-

function initializeHeaderViewTables()
{
  goMnenhy.headers.SetCurrentWindow(window);
  goMnenhy.headers.InitializeHeaderViewTables();
}
function UpdateMessageHeaders()
{
  goMnenhy.headers.SetCurrentWindow(window);
  goMnenhy.headers.UpdateMessageHeaders();
}

function MnenhyOnStartHeadersWrapper()
{
  goMnenhy.headers.SetCurrentWindow(window);
  goMnenhy.headers.OnStartHeaders();
}
messageHeaderSink.onStartHeaders = MnenhyOnStartHeadersWrapper; // named for Enigmail (see .xul)

messageHeaderSink.processHeaders =
function(arHeaderNames, arHeaderValues, aHeaderCountOrDontCollectAddress, abDontCollectAddress)
{ // on 2004-03-12, the nsIMsgHeaderSink interface changed
  // we try to stay backwards compatible
  goMnenhy.headers.SetCurrentWindow(window);
  if (arHeaderNames instanceof Components.interfaces.nsIStringEnumerator)
    goMnenhy.headers.ProcessHeadersNew(arHeaderNames, arHeaderValues, aHeaderCountOrDontCollectAddress);
  else
    goMnenhy.headers.ProcessHeadersOld(arHeaderNames, arHeaderValues, aHeaderCountOrDontCollectAddress, abDontCollectAddress);
}


// need to remember last header view mode to avoid flashing
// (this variable HAS TO EXIST for every mail window!)
var giHeaderView = goMnenhy.headers.gkiViewDirty;


// load necessary subscripts
if (    ("goMnenhy" in this)
     && ("headers" in goMnenhy)
     && (!("InitMsgHdrViewOverlay" in goMnenhy.headers))
   )
{
  if (goMnenhy.Include("chrome://mnenhy-headers/content/mnenhy-headers-msgHdrViewOverlay.js", goMnenhy.headers))
    goMnenhy.headers.InitMsgHdrViewOverlay(goMnenhy);
}