/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mnenhy.
 *
 * The Initial Developer of the Original Code is Karsten Düsterloh <mnenhy@tprac.de>.
 *
 * Portions created by the Initial Developer are Copyright (C) 2002-2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Karsten Düsterloh <mnenhy@tprac.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// |
// |  get a pointer to the one-and-only global Mnenhy object this.goMnenhy
// |
function GetMnenhyPointer()
{
  if (!("goMnenhy" in this))
  { // Get the hidden window and attach Mnenhy there if necessary.
    // Otherwise we would lose the global Components etc. object when closing the
    // window that contains the Mnenhy object - and that'd be pretty *BAD*!
    var oAppShell = Components.classes['@mozilla.org/appshell/appShellService;1']
                              .getService(Components.interfaces.nsIAppShellService);
    var oHiddenWindow = oAppShell.hiddenDOMWindow;
    if (oHiddenWindow)
    {
      if (!("goMnenhy" in oHiddenWindow))
      { // need new Mnenhy object
        var oLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"]
                                .getService(Components.interfaces.mozIJSSubScriptLoader);
        oLoader.loadSubScript("chrome://mnenhy/content/mnenhy.js", oHiddenWindow);
        oHiddenWindow.CreateMnenhy();
      }
    
      if ("goMnenhy" in oHiddenWindow)
      { // reuse global Mnenhy object
        this.goMnenhy = oHiddenWindow.goMnenhy;
        goMnenhy.Log("Using   hidden Mnenhy object here "+this);
      }
      else
      { // still no Mnenhy object :(
        const ksNoMnenhy = "Error! No hidden Mnenhy object found here "+this+"\n";
        dump(ksNoMnenhy);
        try
        {
          Components.classes["@mozilla.org/consoleservice;1"]
                    .getService(Components.interfaces.nsIConsoleService)
                    .logStringMessage(ksNoMnenhy);
        }
        catch(ignored){}
      }
    }
  }
  else
  {
    goMnenhy.Log("Reusing hidden Mnenhy object here "+this);
  }
}

GetMnenhyPointer();
